unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Ed_Buf: TEdit;
    Label1: TLabel;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  c, n1, n2: Int64;

implementation

uses BufferedFile;

{$R *.DFM}
  
procedure TForm1.Button1Click(Sender: TObject);
var   a: TBufferedFile;
b: array[0..23] of char;
c: longint;
f:file;
begin
     FillChar(b,21,#0);
     a := TBufferedFile.Create('c:\luis.aa',FM_READONLY,10);
    a.Read(b,3);
    a.Read(b,1);

    a.Read(b,13);
    a.Read(b,1);
    ShowMessage(inttostr(a.position));
    a.Destroy;

end;

procedure TForm1.Button2Click(Sender: TObject);
var   a: TBufferedFile; f:file;
const b: array[0..20] of char = ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u');
begin
     a := TBufferedFile.Create('c:\luis.aa',FM_WRITEONLY,5);
     a.Write(b,15);
     a.Write(b[18],2);
     ShowMessage(inttostr(a.position));
     a.Destroy;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   f: TBufferedFile;
   i: integer;
     b: array[0..20] of char;
begin
     //perfomance test
     QueryPerformanceFrequency(c);
     QueryPerformanceCounter(n1);
     //fileacess
     f := TBufferedFile.Create('TesteBuf.TST',FM_READONLY, StrToInt(Ed_Buf.Text));
     //read 19,5 kb
     for i := 1 to 1000 do
         F.Read(b,SizeOf(b));

     //performance test
     F.Destroy;
     QueryPerformanceCounter(n2);
     ShowMessage(format('Seconds: %.18f', [(n2 - n1) / c]));
end;

procedure TForm1.Button4Click(Sender: TObject);
var
   f: TBufferedFile;
   i: integer;
const
     b: array[0..20] of char = ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u');
begin
     DeleteFile('bufTest.tst');
     //perfomance test
     QueryPerformanceFrequency(c);
     QueryPerformanceCounter(n1);
     //fileacess
     f := TBufferedFile.Create('TesteBuf.TST',FM_WRITEONLY, StrToInt(Ed_Buf.Text));
     //write 19,5 kb
     for i := 1 to 1000 do
         F.Write(B, SizeOf(B));

     f.Destroy;
     //performance test
     QueryPerformanceCounter(n2);
     ShowMessage(format('Seconds: %.18f', [(n2 - n1) / c]));
end;

procedure TForm1.Button6Click(Sender: TObject);
var
   f: File;
   i:integer;
     b: array[0..20] of char;
begin
     //perfomance test
     QueryPerformanceFrequency(c);
     QueryPerformanceCounter(n1);
     //fileacess
     AssignFile(F,'TesteNot.TST');
     Rewrite(F,1);
     While not Eof(F) do
         BlockRead(F,b,Sizeof(b));
     CloseFile(F);

     //performance test
     QueryPerformanceCounter(n2);
     ShowMessage(format('Seconds: %.18f', [(n2 - n1) / c]));
end;

procedure TForm1.Button5Click(Sender: TObject);
var
   f: File;
   i: integer;
const
     b: array[0..20] of char = ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u');
begin
     //perfomance test
     QueryPerformanceFrequency(c);
     QueryPerformanceCounter(n1);
     //fileacess
     AssignFile(F,'TesteNot.TST');
     Rewrite(F,1);
     for i := 1 to 1000 do
         BlockWrite(F,b,Sizeof(b));
     CloseFile(F);

     //performance test
     QueryPerformanceCounter(n2);
     ShowMessage(format('Seconds: %.18f', [(n2 - n1) / c]));
end;

procedure TForm1.Button7Click(Sender: TObject);
var   a: TBufferedFile; f:file;c: char;
const b: array[0..20] of char = ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u');

begin
 c:='';
    //fillchar(c,sizeof(c),#0);
  {  a := TBufferedFile.Create('c:\luis.aa',FM_WRITEONLY,3);
     a.Seek(2,0);
     a.write(c,1);
     ShowMessage('Pos: '+inttostr(a.position)+' char: '+c);
     a.Destroy;
   }
     assignfile(f,'c:\luis.aa');
     reset(f,1);
     seek(f,2);
   // blockread(f,c,1);
   blockwrite(f,c,1);
     ShowMessage('Pos: '+inttostr(filepos(F))+' char: '+c);
     closefile(f);  
end;

end.

